#ifndef OPTION_ASDL_H
#define OPTION_ASDL_H

namespace option_asdl {

#define ASDL_NAMES struct
ASDL_NAMES option_i {
  enum no_name {
  errexit = 1,
  nounset = 2,
  pipefail = 3,
  inherit_errexit = 4,
  nullglob = 5,
  verbose_errexit = 6,
  verbose_warn = 7,
  noexec = 8,
  xtrace = 9,
  verbose = 10,
  noglob = 11,
  noclobber = 12,
  errtrace = 13,
  posix = 14,
  vi = 15,
  emacs = 16,
  interactive = 17,
  hashall = 18,
  lastpipe = 19,
  failglob = 20,
  extglob = 21,
  nocasematch = 22,
  dotglob = 23,
  extdebug = 24,
  eval_unsafe_arith = 25,
  ignore_flags_not_impl = 26,
  ignore_shopt_not_impl = 27,
  _allow_command_sub = 28,
  _allow_process_sub = 29,
  dynamic_scope = 30,
  redefine_const = 31,
  redefine_source = 32,
  _running_trap = 33,
  _running_hay = 34,
  _no_debug_trap = 35,
  _no_err_trap = 36,
  strict_parse_equals = 37,
  strict_parse_slice = 38,
  strict_argv = 39,
  strict_arith = 40,
  strict_array = 41,
  strict_control_flow = 42,
  strict_env_binding = 43,
  strict_errexit = 44,
  strict_nameref = 45,
  strict_word_eval = 46,
  strict_tilde = 47,
  strict_glob = 48,
  parse_at = 49,
  parse_proc = 50,
  parse_func = 51,
  parse_brace = 52,
  parse_bracket = 53,
  parse_equals = 54,
  parse_paren = 55,
  parse_ysh_string = 56,
  parse_triple_quote = 57,
  simple_word_eval = 58,
  dashglob = 59,
  command_sub_errexit = 60,
  process_sub_fail = 61,
  xtrace_rich = 62,
  xtrace_details = 63,
  sigpipe_status_ok = 64,
  env_obj = 65,
  init_ysh_globals = 66,
  for_loop_frames = 67,
  parse_at_all = 68,
  parse_backslash = 69,
  parse_backticks = 70,
  parse_dollar = 71,
  parse_ignored = 72,
  parse_sh_arith = 73,
  parse_dparen = 74,
  parse_dbracket = 75,
  parse_bare_word = 76,
  parse_word_join = 77,
  no_exported = 78,
  no_init_globals = 79,
  simple_echo = 80,
  simple_eval_builtin = 81,
  simple_test_builtin = 82,
  expand_aliases = 83,
  progcomp = 84,
  histappend = 85,
  hostcomplete = 86,
  cmdhist = 87,
  assoc_expand_once = 88,
  autocd = 89,
  cdable_vars = 90,
  cdspell = 91,
  checkhash = 92,
  checkjobs = 93,
  checkwinsize = 94,
  complete_fullquote = 95,
  direxpand = 96,
  dirspell = 97,
  execfail = 98,
  extquote = 99,
  force_fignore = 100,
  globasciiranges = 101,
  globstar = 102,
  gnu_errfmt = 103,
  histreedit = 104,
  histverify = 105,
  huponexit = 106,
  interactive_comments = 107,
  lithist = 108,
  localvar_inherit = 109,
  localvar_unset = 110,
  login_shell = 111,
  mailwarn = 112,
  no_empty_cmd_completion = 113,
  nocaseglob = 114,
  progcomp_alias = 115,
  promptvars = 116,
  restricted_shell = 117,
  shift_verbose = 118,
  sourcepath = 119,
  xpg_echo = 120,
  ARRAY_SIZE = 121,
  };
};

typedef int option_t;

ASDL_NAMES builtin_i {
  enum no_name {
  colon = 1,
  dot = 2,
  exec_ = 3,
  eval = 4,
  set = 5,
  shift = 6,
  times = 7,
  trap = 8,
  unset = 9,
  readonly = 10,
  local = 11,
  declare = 12,
  typeset = 13,
  export_ = 14,
  extern_ = 15,
  true_ = 16,
  false_ = 17,
  try_ = 18,
  assert_ = 19,
  break_ = 20,
  continue_ = 21,
  return_ = 22,
  exit = 23,
  read = 24,
  echo = 25,
  printf = 26,
  mapfile = 27,
  readarray = 28,
  cd = 29,
  pushd = 30,
  popd = 31,
  dirs = 32,
  pwd = 33,
  source = 34,
  umask = 35,
  ulimit = 36,
  wait = 37,
  jobs = 38,
  fg = 39,
  bg = 40,
  shopt = 41,
  complete = 42,
  compgen = 43,
  compopt = 44,
  compadjust = 45,
  compexport = 46,
  getopts = 47,
  builtin = 48,
  command = 49,
  type = 50,
  hash = 51,
  help = 52,
  history = 53,
  alias = 54,
  unalias = 55,
  bind = 56,
  append = 57,
  write = 58,
  json = 59,
  json8 = 60,
  pp = 61,
  hay = 62,
  haynode = 63,
  use = 64,
  error = 65,
  failed = 66,
  fork = 67,
  forkwait = 68,
  redir = 69,
  fopen = 70,
  shvar = 71,
  ctx = 72,
  invoke = 73,
  runproc = 74,
  boolstatus = 75,
  test = 76,
  bracket = 77,
  push_registers = 78,
  source_guard = 79,
  is_main = 80,
  cat = 81,
  sleep = 82,
  ARRAY_SIZE = 83,
  };
};

typedef int builtin_t;


}  // namespace option_asdl

#endif  // OPTION_ASDL_H
